SystemOrganization addCategory: #TechnologyTreeOptimizationOfTheCivilizationRevolution!

DependencySorter subclass: #CRTechDependencySorter
	instanceVariableNames: 'techs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

!CRTechDependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 00:50'!
prerequisitesOf: aTech

	^aTech requiredTechs  ! !

!CRTechDependencySorter methodsFor: 'accessing' stamp: 'hjo 9/14/2011 00:49'!
techs
	^ techs! !

!CRTechDependencySorter methodsFor: 'accessing' stamp: 'hjo 9/14/2011 00:49'!
techs: anArray
	techs := anArray! !

TestCase subclass: #CRGameTechSetUpTest
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:48'!
setUp

	game := CRGame new.! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:49'!
testLevel1

	self assert: (game countOfTechsOfLevel:1) equals: 4.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:58'!
testLevel10

	self assert: (game countOfTechsOfLevel:10) equals: 2.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:58'!
testLevel11

	self assert: (game countOfTechsOfLevel:11) equals: 2.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:58'!
testLevel12

	self assert: (game countOfTechsOfLevel:12) equals: 1.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:51'!
testLevel2

	self assert: (game countOfTechsOfLevel:2) equals: 4.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:52'!
testLevel3

	self assert: (game countOfTechsOfLevel:3) equals: 5.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:56'!
testLevel4

	self assert: (game countOfTechsOfLevel:4) equals: 5.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:56'!
testLevel5

	self assert: (game countOfTechsOfLevel:5) equals: 5.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:56'!
testLevel6

	self assert: (game countOfTechsOfLevel:6) equals: 4.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:57'!
testLevel7

	self assert: (game countOfTechsOfLevel:7) equals: 5.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:57'!
testLevel8

	self assert: (game countOfTechsOfLevel:8) equals: 6.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:57'!
testLevel9

	self assert: (game countOfTechsOfLevel:9) equals: 4.
	! !

Object subclass: #CRBuilding
	uses: HashProofTrait
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

CRBuilding class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:27'!
allBuildings

	|all|
	all := (self class selectors select: [:each| each beginsWith: 'building' ])
		collect: [:sym| self perform: sym  ].
	^all! !

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:32'!
buildingAqueduct
	^self named: 'Aqueduct'! !

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:46'!
buildingBank
	^self named: 'Bank'! !

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:28'!
buildingBarracks
	^self named: 'Barracks'! !

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:16'!
buildingCourthouse
	^self named: 'Courthouse'! !

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:56'!
buildingGranary
	^self named: 'Granary'! !

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:29'!
buildingLibrary
	^self named: 'Library'! !

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:37'!
buildingMarket
	^self named: 'Market'! !

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:20'!
buildingTradingPost
	^self named: 'Trading Post'! !

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:53'!
buildingUniversity
	^self named: 'University'! !

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:59'!
buildingWall
	^self named: 'Wall'! !

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:20'!
buildingWorkshop
	^self named: 'Workshop'! !

!CRBuilding classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:09'!
named: aByteString 
	^self new
		name: aByteString! !

!CRBuilding methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:38'!
name
	^name! !

!CRBuilding methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:09'!
name: aByteString 
	name := aByteString ! !

Object subclass: #CRGame
	instanceVariableNames: 'techs techsAquired buildings units wonders governmentTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:14'!
aquireTechNamed: aString

	techsAquired add: (self techNamed: aString)! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:55'!
aquireTechOrderToReachTechNamed: aByteString 

	| ds |
	ds := CRTechDependencySorter new.
	ds techs: techs.
	ds insert: (self techNamed: aByteString).
	techsAquired addAll: ds sortedCollection.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:16'!
aquireTechsNamed: anArray 

	anArray do: [:each| self aquireTechNamed: each ]! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:38'!
buildingNamed: aByteString 
	^buildings detect: [:each| each name = aByteString ]! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:55'!
countOfTechsOfLevel: aSmallInteger 

	^(self techsOfLevel: aSmallInteger) size! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:25'!
governmentTypeNamed: aByteString 
	^governmentTypes detect: [:each| each name = aByteString ] ! !

!CRGame methodsFor: 'initialize-release' stamp: 'hjo 9/14/2011 02:13'!
initialize

	super initialize.
	self initializeTechs.
	techsAquired := Set new.! !

!CRGame methodsFor: 'initialize-release' stamp: 'HwaJong 1/21/2013 00:25'!
initializeTechs

	techs := CRTech allTechs.
	buildings := CRBuilding allBuildings.
	units := CRUnit allUnits.
	wonders := CRWonder allWonders.
	governmentTypes := CRGovernmentType allGovernmentTypes.
	self setUpTechRequirements.! !

!CRGame methodsFor: 'initialize-release' stamp: 'HwaJong 1/20/2013 23:53'!
setUpTech: techName requires: anArray

	^self setUpTech: techName requires: anArray unlocks: {}! !

!CRGame methodsFor: 'initialize-release' stamp: 'HwaJong 1/20/2013 23:46'!
setUpTech: techName requires: strings1 unlocks: strings2 

	(self techNamed: techName) 
		requiredTechs: (strings1 collect: [:requiredTechName| self techNamed: requiredTechName]);
		unlockings: (strings2 collect: [:unlockingName| self unlockingNamed: unlockingName]).! !

!CRGame methodsFor: 'initialize-release' stamp: 'HwaJong 1/20/2013 23:44'!
setUpTech: aByteString unlocks: anArray 
	^self setUpTech: aByteString requires: {} unlocks: anArray ! !

!CRGame methodsFor: 'initialize-release' stamp: 'HwaJong 1/21/2013 01:54'!
setUpTechRequirements

	self setUpTech: 'Alphabet' unlocks: {'Library'. 'Oracle of Delphi'}.
	self setUpTech: 'Bronze Working' unlocks:{'Barracks'. 'Colossus of Rhodes'. 'Archer'}.
	self setUpTech: 'Pottery' unlocks:{'Granary'}.
	self setUpTech: 'Ceremonial Burial' requires: {'Pottery'}.
	self setUpTech: 'Iron Working' requires: {'Bronze Working'}.
	self setUpTech: 'Masonry' requires: {'Pottery'} unlocks: {'Wall'. 'Great Wall'}.
	self setUpTech: 'Writing' requires:  {'Alphabet'}.
	self setUpTech: 'Code of Laws' requires:  {'Alphabet'. 'Writing'} unlocks: {'Trading Post'. 'Republic'}.
	self setUpTech: 'Construction' requires:  {'Iron Working'. 'Masonry'} unlocks: {'Workshop'}.
	self setUpTech: 'Irrigation' requires:  {'Pottery'. 'Masonry'}.
	self setUpTech: 'Literacy' requires:  {'Alphabet'. 'Writing'} unlocks: {'Courthouse'. 'Great Theatre'}.
	self setUpTech: 'Mathematics' requires:  {'Masonry'. 'Writing'} unlocks: {'Catapult'}.
	self setUpTech: 'Currency' requires:  {'Bronze Working'. 'Code of Laws'} unlocks: {'Caravan'. 'Market'. 'Trade Fair of Troyes'}.
	self setUpTech: 'Democracy' requires:  {'Code of Laws'. 'Literacy'} unlocks: {'Pikemen'. 'Magna Carta'}.
	self setUpTech: 'Engineering' requires:  {'Construction'. 'Mathematics'} unlocks: {'Aqueduct'}.
	self setUpTech: 'Monarchy' requires:  {'Code of Laws'. 'Ceremonial Burial'. 'Writing'} unlocks: {'Himeji Samurai Castle'. 'Monarchy'}.
	self setUpTech: 'Navigation' requires:  {'Writing'. 'Mathematics'}.
	self setUpTech: 'Feudalism' requires:  {'Monarchy'. 'Horseback Riding'} unlocks: {'Knight'}.
	self setUpTech: 'Religion' requires:  {'Monarchy'. 'Ceremonial Burial'}.
	self setUpTech: 'Banking' requires:  {'Currency'. 'Code of Laws'. 'Literacy'} unlocks: {'Bank'}.
	self setUpTech: 'University' requires:  {'Democracy'. 'Mathematics'. 'Literacy'} unlocks: {'University'. 'Oxford University'}.
	self setUpTech: 'Invention' requires:  {'Engineering'. 'Literacy'} unlocks: {'Leonardo Workshop'}.
	self setUpTech: 'Gunpowder' requires:  {'Feudalism'. 'Invention'} unlocks: {'Riflemen'}.
	self setUpTech: 'Metallurgy' requires:  {'University'. 'Engineering'. 'Iron Working'} unlocks: {'Cannon'}.
	self setUpTech: 'Printing Press' requires:  {'Religion'. 'University'}.
	self setUpTech: 'Steam Power' requires:  {'Invention'. 'Engineering'. 'Iron Working'}.
	self setUpTech: 'Combustion' requires:  {'Gunpowder'. 'Metallurgy'. 'Steam Power'}.
	self setUpTech: 'Electricity' requires:  {'Metallurgy'. 'Engineering'. 'Steam Power'}.
	self setUpTech: 'Industrialization' requires:  {'Banking'. 'Steam Power'}.
	self setUpTech: 'Railroad' requires:  {'Steam Power'}.
	self setUpTech: 'Steel' requires:  {'Metallurgy'. 'Steam Power'}.
	self setUpTech: 'Communism' requires:  {'Industrialization'. 'University'}.
	self setUpTech: 'Flight' requires:  {'Combustion'. 'Metallurgy'. 'Invention'}.
	self setUpTech: 'Mass Production' requires:  {'Industrialization'. 'Railroad'}.
	self setUpTech: 'The Corporation' requires:  {'Industrialization'. 'Banking'}.
	self setUpTech: 'Atomic Theory' requires:  {'University'. 'Invention'. 'Electricity'}.
	self setUpTech: 'The Automobile' requires:  {'Combustion'. 'Steel'}.
	self setUpTech: 'Electronics' requires:  {'The Corporation'. 'Electricity'}.
	self setUpTech: 'Mass Media' requires:  {'The Corporation'. 'Printing Press'}.
	self setUpTech: 'Advanced Flight' requires:  {'Industrialization'. 'Flight'}.
	self setUpTech: 'Nuclear Power' requires:  {'Mass Production'. 'Atomic Theory'}.
	self setUpTech: 'Networking' requires:  {'Electronics'. 'The Corporation'}.
	self setUpTech: 'Space Flight' requires:  {'Electronics'. 'Advanced Flight'. 'Nuclear Power'}.
	self setUpTech: 'Globalization' requires:  {'Networking'. 'Mass Media'}.
	self setUpTech: 'Superconductor' requires:  {'Space Flight'. 'Mass Production'}.
	self setUpTech: 'Future Technology' requires:  {'Globalization'. 'Superconductor'. 'Advanced Flight'}.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:07'!
techNamed: aByteString 

	^techs detect: [:each| each techName = aByteString ] ifNone: [self error: aByteString , ' not a tech name']! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 19:53'!
techOrderToReachTechNamed: aByteString 

	| ds |
	ds := CRTechDependencySorter new.
	ds techs: techs.
	ds insert: (self techNamed: aByteString).
	^(ds sortedCollection asSortedCollection: (UnarySortDescriptor ascendingBy: #level)) collect: #techName.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:54'!
techsOfLevel: aSmallInteger 

	^techs select: [:each| each level = aSmallInteger ]  ! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 20:05'!
unaquiredTechOrderToReachTechNamed: aByteString 
	
	| ds |
	ds := CRTechDependencySorter new.
	ds techs: techs.
	ds insert: (self techNamed: aByteString).
	^((ds sortedCollection asSortedCollection: (UnarySortDescriptor ascendingBy: #level)) copyWithoutAll: techsAquired) collect: #techName.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 21:00'!
unaquiredTechOrderToReachTechsNamed: anArray 
	
	| ds |
	ds := CRTechDependencySorter new.
	ds techs: techs.
	anArray do: [:aByteString| ds insert: (self techNamed: aByteString)].
	^((ds sortedCollection asSortedCollection: (UnarySortDescriptor ascendingBy: #level)) copyWithoutAll: techsAquired) collect: #techName.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:37'!
unitNamed: aByteString 

	^units detect: [:each| each name = aByteString ]! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:26'!
unlockingNamed: aByteString 
	^(buildings, units, wonders, governmentTypes) detect: [:each| each name = aByteString ] ifNone: [self error: aByteString, ' is missing']! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:40'!
wonderNamed: aByteString 
	^wonders detect: [:each| each name = aByteString ] ! !

Object subclass: #CRGovernmentType
	uses: HashProofTrait
	instanceVariableNames: 'name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

CRGovernmentType class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!CRGovernmentType classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:26'!
allGovernmentTypes
	^(self class selectors select: [:each| each beginsWith: 'governmentType' ])
		collect: [:sym| self perform: sym  ]! !

!CRGovernmentType classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:35'!
governmentTypeDemocracy
	^self named: 'Democracy' description: 'Science and Gold production will increase by 50%, however people will refuse to allow a declaration of war.'! !

!CRGovernmentType classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:28'!
governmentTypeDespotism
	^self named: 'Despotism' description: 'default'! !

!CRGovernmentType classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:31'!
governmentTypeMonarchy
	^self named: 'Monarchy' description: 'Palace culture bonus will double'! !

!CRGovernmentType classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:29'!
governmentTypeRepublic
	^self named: 'Republic' description: 'Settlers can be built for only one population'! !

!CRGovernmentType classSide methodsFor: 'instance creation' stamp: 'HwaJong 1/21/2013 00:27'!
named: aByteString description: aString
	^self new
		name: aByteString;
		description: aString! !

!CRGovernmentType classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:23'!
unitSpy
	^self named: 'Spy'! !

!CRGovernmentType methodsFor: 'accessing' stamp: 'HwaJong 1/21/2013 00:28'!
description: aByteString 
	description := aByteString ! !

!CRGovernmentType methodsFor: 'accessing' stamp: 'HwaJong 1/21/2013 00:23'!
name
	^name! !

!CRGovernmentType methodsFor: 'accessing' stamp: 'HwaJong 1/21/2013 00:23'!
name: aByteString 
	name := aByteString! !

Object subclass: #CRTech
	uses: HashProofTrait
	instanceVariableNames: 'requiredTechs techName bonus level unlockings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

CRTech class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:19'!
allTechs

	|techs|
	techs := (self class selectors select: [:each| each beginsWith: 'tech' ])
		collect: [:sym| self perform: sym  ].
	^techs! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:18'!
newTechName: aByteString level: aSmallInteger

	|instance|
	instance := self new.
	instance techName: aByteString.
	instance level: aSmallInteger.
	^instance! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:32'!
newTechName: aByteString level: aSmallInteger bonus: aString

	|instance|
	instance := self new.
	instance techName: aByteString.
	instance level: aSmallInteger.
	instance bonus: aString.
	^instance! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:44'!
techAdvancedFlight

	^self newTechName: 'Advanced Flight' level: 9! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:17'!
techAlphabet

	^self newTechName: 'Alphabet' level: 1! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:43'!
techAtomicTheory

	^self newTechName: 'Atomic Theory' level: 8! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:49'!
techBanking

	^self newTechName: 'Banking' level: 5 bonus: 'first bonus: 100 gold pieces'! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:32'!
techBronzeWorking

	^self newTechName: 'Bronze Working' level: 1 bonus: 'utilize Fish resources (2 extra food)'! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:18'!
techCeremonialBurial

	^self newTechName: 'Ceremonial Burial' level: 2! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:23'!
techCodeOfLaws

	^self newTechName: 'Code of Laws' level: 3 bonus: 'utilize Cattle resources (3 extra food). first bonus: Trading Post built in Seatle'! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:39'!
techCombustion

	^self newTechName: 'Combustion' level: 7! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:41'!
techCommunism

	^self newTechName: 'Communism' level: 8! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:23'!
techConstruction

	^self newTechName: 'Construction' level: 3 bonus: 'utilize Oak resource(3 extra resource)'! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:35'!
techCurrency

	^self newTechName: 'Currency' level: 4! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:35'!
techDemocracy

	^self newTechName: 'Democracy' level: 4! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:40'!
techElectricity

	^self newTechName: 'Electricity' level: 7! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:43'!
techElectronics

	^self newTechName: 'Electronics' level: 9! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:35'!
techEngineering

	^self newTechName: 'Engineering' level: 4! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:17'!
techFeudalism

	^self newTechName: 'Feudalism' level: 5 bonus: 'utilize Game resource (3 extra food). first bonus: Knights built in Washington'! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:42'!
techFlight

	^self newTechName: 'Flight' level: 8! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:46'!
techFutureTechnology

	^self newTechName: 'Future Technology' level: 12! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:45'!
techGlobalization

	^self newTechName: 'Globalization' level: 11! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:53'!
techGunpowder

	^self newTechName: 'Gunpowder' level: 6 bonus: 'utilize Sulfer resources(3 extra resources)'! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:18'!
techHorsebackRiding

	^self newTechName: 'Horseback Riding' level: 1! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:40'!
techIndustrialization

	^self newTechName: 'Industrialization' level: 7! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:37'!
techInvention

	^self newTechName: 'Invention' level: 5! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:18'!
techIronWorking

	^self newTechName: 'Iron Working' level: 2! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:34'!
techIrrigation

	^self newTechName: 'Irrigation' level: 3! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:19'!
techLiteracy

	^self newTechName: 'Literacy' level: 3 bonus: 'utilize Silk resources (3 extra culture). first bonus: +1 science in each city'! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:03'!
techMasonry

	^self newTechName: 'Masonry' level: 2 bonus: 'utilize Marble resources (2 extra resources)'! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:44'!
techMassMedia

	^self newTechName: 'Mass Media' level: 9! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:42'!
techMassProduction

	^self newTechName: 'Mass Production' level: 8! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:14'!
techMathematics

	^self newTechName: 'Mathematics' level: 3 bonus: 'first bonus: Catapult built in Washington'! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:38'!
techMetallurgy

	^self newTechName: 'Metallurgy' level: 6! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:29'!
techMonarchy

	^self newTechName: 'Monarchy' level: 4 bonus: 'utilize Dye resources (3 extra trade). first bonus: Great Person appears'! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:36'!
techNavigation

	^self newTechName: 'Navigation' level: 4! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:45'!
techNetworking

	^self newTechName: 'Networking' level: 10! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:44'!
techNuclearPower

	^self newTechName: 'Nuclear Power' level: 9! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:58'!
techPottery

	^self newTechName: 'Pottery' level: 1 bonus: 'utilize Wine resources (2 extra trade)'! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:38'!
techPrintingPress

	^self newTechName: 'Printing Press' level: 6! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:40'!
techRailroad

	^self newTechName: 'Railroad' level: 7! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:37'!
techReligion

	^self newTechName: 'Religion' level: 5! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:45'!
techSpaceFlight

	^self newTechName: 'Space Flight' level: 10! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:39'!
techSteamPower

	^self newTechName: 'Steam Power' level: 6! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:41'!
techSteel

	^self newTechName: 'Steel' level: 7! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:46'!
techSuperconductor

	^self newTechName: 'Superconductor' level: 11! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:43'!
techTheAutomobile

	^self newTechName: 'The Automobile' level: 8! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:42'!
techTheCorporation

	^self newTechName: 'The Corporation' level: 8! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:37'!
techUniversity

	^self newTechName: 'University' level: 5! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:07'!
techWriting

	^self newTechName: 'Writing' level: 2 bonus: 'first bonus: Spy built in Washington'! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
bonus
	^ bonus! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
bonus: anObject
	bonus := anObject! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:17'!
gettersForEquality

	^#(techName)! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 00:55'!
initialize 

	super initialize.
	requiredTechs := {}.! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:51'!
level

	^ level! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:04'!
level: aSmallInteger 

	level := aSmallInteger! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
requiredTechs
	^ requiredTechs! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
requiredTechs: anObject
	requiredTechs := anObject! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
techName
	^ techName! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
techName: anObject
	techName := anObject! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:10'!
unlockings: anArray 
	unlockings := anArray ! !

Object subclass: #CRUnit
	uses: HashProofTrait
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

CRUnit class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!CRUnit classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:34'!
allUnits
	|all|
	all := (self class selectors select: [:each| each beginsWith: 'unit' ])
		collect: [:sym| self perform: sym  ].
	^all! !

!CRUnit classSide methodsFor: 'instance creation' stamp: 'HwaJong 1/20/2013 23:14'!
named: aByteString 
	^self new
		name: aByteString! !

!CRUnit classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:35'!
unitArcher
	^self named: 'Archer'! !

!CRUnit classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:54'!
unitCannon
	^self named: 'Cannon'! !

!CRUnit classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:36'!
unitCaravan
	^self named: 'Caravan'! !

!CRUnit classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:08'!
unitCatapult
	^self named: 'Catapult'! !

!CRUnit classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:16'!
unitKnight
	^self named: 'Knight'! !

!CRUnit classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:31'!
unitPikemen
	^self named: 'Pikemen'! !

!CRUnit classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:55'!
unitRiflemen
	^self named: 'Riflemen'! !

!CRUnit classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:05'!
unitSpy
	^self named: 'Spy'! !

!CRUnit methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:37'!
name
	^name! !

!CRUnit methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:14'!
name: aByteString 
	name := aByteString! !

Object subclass: #CRWonder
	uses: HashProofTrait
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

CRWonder class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!CRWonder classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:39'!
allWonders
	|all|
	all := (self class selectors select: [:each| each beginsWith: 'wonder' ])
		collect: [:sym| self perform: sym  ].
	^all! !

!CRWonder classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:10'!
named: aByteString 
	^self new
		name: aByteString! !

!CRWonder classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:41'!
wonderColossusOfRhodes
	^self named: 'Colossus of Rhodes'! !

!CRWonder classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:05'!
wonderGreatLibrary
	^self named: 'Great Library'! !

!CRWonder classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:16'!
wonderGreatTheatre
	^self named: 'Great Theatre'! !

!CRWonder classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:01'!
wonderGreatWall
	^self named: 'Great Wall'! !

!CRWonder classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:30'!
wonderHimejiSamuraiCastle
	^self named: 'Himeji Samurai Castle'! !

!CRWonder classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:45'!
wonderLeonardoWorkshop
	^self named: 'Leonardo Workshop'! !

!CRWonder classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:31'!
wonderMagnaCarta
	^self named: 'Magna Carta'! !

!CRWonder classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:52'!
wonderOracleOfDelphi
	^self named: 'Oracle of Delphi'! !

!CRWonder classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:54'!
wonderOxfordUniversity
	^self named: 'Oxford University'! !

!CRWonder classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:37'!
wonderTradeFairOfTroyes
	^self named: 'Trade Fair of Troyes'! !

!CRWonder methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:41'!
name
	^name! !

!CRWonder methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:10'!
name: aByteString 
	name := aByteString ! !
